{
  "openapi": "3.1.0",
  "info": {
    "title": "Databar.ai API",
    "description": "\n# Authentication\n\nDatabar uses API keys to allow access to the API. You can find your API key in your workspace home page, but to use the REST API you\u2019ll first need to schedule a call with us.\nOur API expects the API key to be included in all API requests to the server in the Header of your request with the key `x-apikey`.\nTo find your API key, head over to your Databar workspace and click Integrations.\n\n**Example:**\n\n`bash\ncurl https://api.databar.ai/v1/user/me -H x-apikey: {YOUR_API_KEY}`",
    "contact": {
      "email": "info@databar.ai"
    },
    "version": "0.1.2"
  },
  "paths": {
    "/v1/user/me": {
      "get": {
        "tags": [
          "User"
        ],
        "summary": "Get user info",
        "description": "Get information about your current account.",
        "operationId": "me_v1_user_me_get",
        "parameters": [
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "User info",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/User"
                },
                "example": {
                  "first_name": "David",
                  "email": "david@databar.ai",
                  "balance": 100.0,
                  "plan": "Pro",
                  "workspace": "a1b2c3d4-e5f6-7890-abcd-ef1234567890"
                }
              }
            }
          },
          "429": {
            "description": "Upstream rate limit; retry after Retry-After when present",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Too many requests. Please retry later."
                }
              }
            }
          },
          "403": {
            "description": "Forbidden access",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Forbidden"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/enrichments/": {
      "get": {
        "tags": [
          "Enrichment"
        ],
        "summary": "Get available enrichments",
        "description": "Retrieves enrichments available on Databar. Use the search parameter to filter results by keyword.\n\n**Pagination:** pass `page` to receive a paginated envelope (`{items, page, limit, has_next_page, total_count}`).\n\n**\u26a0\ufe0f Deprecated:** calling without `page` returns a plain JSON array for backward compatibility. This form will be removed in a future version \u2014 always pass `page` for new integrations.",
        "operationId": "Enrichments_v1_enrichments__get",
        "parameters": [
          {
            "name": "q",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "minLength": 3,
              "title": "Search Query",
              "description": "Query string used for searching through enrichments."
            },
            "description": "Query string used for searching through enrichments.",
            "example": "Databar"
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "anyOf": [
                {
                  "type": "integer",
                  "minimum": 1
                },
                {
                  "type": "null"
                }
              ],
              "description": "Page number. Omit for a plain list.",
              "title": "Page"
            },
            "description": "Page number. Omit for a plain list."
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "maximum": 500,
              "minimum": 1,
              "description": "Items per page (max 500). Only used with page.",
              "default": 50,
              "title": "Limit"
            },
            "description": "Items per page (max 500). Only used with page."
          },
          {
            "name": "authorized_only",
            "in": "query",
            "required": false,
            "schema": {
              "type": "boolean",
              "description": "When true, hides enrichments that require a user-provided API key (BYOK) unless the user has already connected that integration.",
              "default": true,
              "title": "Authorized Only"
            },
            "description": "When true, hides enrichments that require a user-provided API key (BYOK) unless the user has already connected that integration."
          },
          {
            "name": "category",
            "in": "query",
            "required": false,
            "schema": {
              "anyOf": [
                {
                  "type": "string"
                },
                {
                  "type": "null"
                }
              ],
              "description": "Filter by enrichment category name (e.g. 'Company Data', 'Contact Finding').",
              "title": "Category"
            },
            "description": "Filter by enrichment category name (e.g. 'Company Data', 'Contact Finding')."
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "List of enrichments (plain array or paginated envelope)",
            "content": {
              "application/json": {
                "schema": {},
                "examples": {
                  "plain_list": {
                    "summary": "Without page param (default, backward-compatible)",
                    "value": [
                      {
                        "id": 1,
                        "name": "Enrichment 1",
                        "description": "Enrichment 1 description",
                        "data_source": "api_example",
                        "price": 0.01,
                        "pricing": {
                          "type": "fixed"
                        },
                        "auth_method": "none",
                        "rank": 100,
                        "search_keywords": "keyword1, keyword2",
                        "category": [
                          {
                            "id": 1,
                            "name": "Company Data"
                          }
                        ]
                      }
                    ]
                  },
                  "paginated": {
                    "summary": "With ?page=1&limit=50",
                    "value": {
                      "items": [
                        {
                          "id": 1,
                          "name": "Enrichment 1",
                          "description": "Enrichment 1 description",
                          "data_source": "api_example",
                          "price": 0.01,
                          "pricing": {
                            "type": "fixed"
                          },
                          "auth_method": "none",
                          "rank": 100,
                          "search_keywords": "keyword1, keyword2",
                          "category": [
                            {
                              "id": 1,
                              "name": "Company Data"
                            }
                          ]
                        },
                        {
                          "id": 2,
                          "name": "Enrichment with dynamic pricing",
                          "description": "Price depends on size param",
                          "data_source": "api_example",
                          "price": 0.01,
                          "pricing": {
                            "type": "per_parameter",
                            "parameter": "size"
                          },
                          "auth_method": "none",
                          "rank": 80,
                          "search_keywords": "",
                          "category": []
                        }
                      ],
                      "page": 1,
                      "limit": 50,
                      "has_next_page": false,
                      "total_count": 2
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Forbidden"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/enrichments/{enrichment_id}": {
      "get": {
        "tags": [
          "Enrichment"
        ],
        "summary": "Get a specific enrichment",
        "description": "Retrieve detailed information about a specific enrichment by its ID.",
        "operationId": "get_enrichment_v1_enrichments__enrichment_id__get",
        "parameters": [
          {
            "name": "enrichment_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the enrichment to retrieve",
              "title": "Enrichment Id"
            },
            "description": "The ID of the enrichment to retrieve"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EnrichmentParams"
                },
                "example": {
                  "id": 1,
                  "name": "Enrichment Example",
                  "description": "Description for Enrichment Example",
                  "price": 0.01,
                  "pricing": {
                    "type": "per_parameter",
                    "parameter": "size"
                  },
                  "params": [
                    {
                      "name": "param1",
                      "is_required": true,
                      "type_field": "text",
                      "description": "Enter a value"
                    },
                    {
                      "name": "country",
                      "is_required": false,
                      "type_field": "select",
                      "description": "Select a country",
                      "choices": {
                        "mode": "inline",
                        "items": [
                          {
                            "id": "us",
                            "name": "United States"
                          },
                          {
                            "id": "gb",
                            "name": "United Kingdom"
                          }
                        ]
                      }
                    },
                    {
                      "name": "industry",
                      "is_required": false,
                      "type_field": "select",
                      "description": "Select an industry",
                      "choices": {
                        "mode": "remote",
                        "endpoint": "/v1/enrichments/1/params/industry/choices"
                      }
                    },
                    {
                      "name": "categories",
                      "is_required": false,
                      "type_field": "mselect",
                      "description": "Select categories",
                      "choices": {
                        "mode": "inline",
                        "items": [
                          {
                            "id": "tech",
                            "name": "Technology"
                          },
                          {
                            "id": "finance",
                            "name": "Finance"
                          }
                        ]
                      }
                    }
                  ],
                  "response_fields": [
                    {
                      "name": "field1",
                      "type_field": "text"
                    }
                  ]
                }
              }
            }
          },
          "403": {
            "description": "Forbidden access"
          },
          "404": {
            "description": "Enrichment not found"
          },
          "406": {
            "description": "Forbidden access",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Check the number of remaining credits or the tariff plan."
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/enrichments/{enrichment_id}/run": {
      "post": {
        "tags": [
          "Enrichment"
        ],
        "summary": "Run an enrichment task",
        "description": "Executes an enrichment task with the provided parameters.\n\n**Pricing:** for enrichments with `pricing.type == \"per_parameter\"`, the cost per request is `price \u00d7 params[pricing.parameter]`. Check `GET /v1/enrichments/{id}` to see the pricing details.",
        "operationId": "run_v1_enrichments__enrichment_id__run_post",
        "parameters": [
          {
            "name": "enrichment_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the enrichment to run",
              "title": "Enrichment Id"
            },
            "description": "The ID of the enrichment to run"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/app__api__v1__enrichment__Request"
              },
              "examples": {
                "normal": {
                  "summary": "A standard request",
                  "description": "Single-page enrichment run",
                  "value": {
                    "params": {
                      "param1": "value1",
                      "param2": "value2"
                    }
                  }
                },
                "with_pagination": {
                  "summary": "Request with pagination",
                  "description": "Fetch 3 pages of results. Each page is billed separately.",
                  "value": {
                    "params": {
                      "query": "software engineer",
                      "location": "New York"
                    },
                    "pagination": {
                      "pages": 3
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/app__api__v1__enrichment__Task"
                },
                "example": {
                  "task_id": "123e4567-e89b-12d3-a456-426614174000",
                  "status": "processing"
                }
              }
            }
          },
          "400": {
            "description": "Invalid params",
            "content": {
              "application/json": {
                "example": {
                  "error": "INVALID_PARAMS",
                  "detail": "Row 1: param1: This field is required.",
                  "rows": [
                    {
                      "position": 1,
                      "fields": {
                        "param1": [
                          "This field is required."
                        ]
                      }
                    }
                  ]
                }
              }
            }
          },
          "406": {
            "description": "Forbidden access",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Check the number of remaining credits or the tariff plan."
                }
              }
            }
          },
          "403": {
            "description": "Forbidden access",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Forbidden"
                }
              }
            }
          },
          "404": {
            "description": "Enrichment not found"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/enrichments/{enrichment_id}/bulk-run": {
      "post": {
        "tags": [
          "Enrichment"
        ],
        "summary": "Run Bulk Enrichment",
        "description": "Submits a bulk enrichment run for the specified enrichment ID.\n\n**Pricing:** for enrichments with `pricing.type == \"per_parameter\"`, the cost per request is `price \u00d7 params[pricing.parameter]`. Check `GET /v1/enrichments/{id}` to see the pricing details.",
        "operationId": "bulk_run_v1_enrichments__enrichment_id__bulk_run_post",
        "parameters": [
          {
            "name": "enrichment_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the enrichment to run",
              "title": "Enrichment Id"
            },
            "description": "The ID of the enrichment to run"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/app__api__v1__enrichment__BulkRequest"
              },
              "examples": {
                "normal": {
                  "summary": "A standard request",
                  "description": "Single-page bulk enrichment run",
                  "value": {
                    "params": [
                      {
                        "param1": "value1",
                        "param2": "value2"
                      }
                    ]
                  }
                },
                "with_pagination": {
                  "summary": "Bulk request with pagination",
                  "description": "Fetch 3 pages per row. Each page per row is billed separately.",
                  "value": {
                    "params": [
                      {
                        "query": "software engineer",
                        "location": "New York"
                      },
                      {
                        "query": "data scientist",
                        "location": "San Francisco"
                      }
                    ],
                    "pagination": {
                      "pages": 3
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successfully submitted the bulk enrichment run",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/app__api__v1__enrichment__Task"
                },
                "example": {
                  "task_id": "123e4567-e89b-12d3-a456-426614174000",
                  "status": "processing"
                }
              }
            }
          },
          "406": {
            "description": "Forbidden access",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Check the number of remaining credits or the tariff plan."
                }
              }
            }
          },
          "403": {
            "description": "Forbidden access",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Forbidden"
                }
              }
            }
          },
          "404": {
            "description": "Enrichment ID does not exist"
          },
          "400": {
            "description": "Invalid params",
            "content": {
              "application/json": {
                "example": {
                  "error": "INVALID_PARAMS",
                  "detail": "Row 1: param1: This field is required.",
                  "rows": [
                    {
                      "position": 1,
                      "fields": {
                        "param1": [
                          "This field is required."
                        ]
                      }
                    }
                  ]
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/enrichments/{enrichment_id}/params/{param_slug}/choices": {
      "get": {
        "tags": [
          "Enrichment"
        ],
        "summary": "Get choices for a parameter",
        "description": "Returns paginated choices for a select/mselect parameter. Use the `q` parameter to search, and `page`/`limit` for pagination.",
        "operationId": "get_param_choices_v1_enrichments__enrichment_id__params__param_slug__choices_get",
        "parameters": [
          {
            "name": "enrichment_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the enrichment",
              "title": "Enrichment Id"
            },
            "description": "The ID of the enrichment"
          },
          {
            "name": "param_slug",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "description": "The parameter slug/name",
              "title": "Param Slug"
            },
            "description": "The parameter slug/name"
          },
          {
            "name": "q",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "description": "Search query to filter choices",
              "title": "Q"
            },
            "description": "Search query to filter choices"
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "minimum": 1,
              "description": "Page number",
              "default": 1,
              "title": "Page"
            },
            "description": "Page number"
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "maximum": 500,
              "minimum": 1,
              "description": "Items per page (max 500)",
              "default": 100,
              "title": "Limit"
            },
            "description": "Items per page (max 500)"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Paginated list of choices",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ChoicesResponse"
                },
                "example": {
                  "items": [
                    {
                      "id": "us",
                      "name": "United States"
                    },
                    {
                      "id": "gb",
                      "name": "United Kingdom"
                    }
                  ],
                  "page": 1,
                  "limit": 100,
                  "has_next_page": false,
                  "total_count": 2
                }
              }
            }
          },
          "403": {
            "description": "Forbidden access"
          },
          "404": {
            "description": "Enrichment or parameter not found"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/exporters/": {
      "get": {
        "tags": [
          "Exporter"
        ],
        "summary": "Get available exporters",
        "description": "Retrieves exporters (CRM/destination integrations) available on Databar.\n\n**Pagination:** pass `page` to receive a paginated envelope (`{items, page, limit, has_next_page, total_count}`).\n\n**Deprecated:** calling without `page` returns a plain JSON array for backward compatibility. This form will be removed in a future version -- always pass `page` for new integrations.",
        "operationId": "Exporters_v1_exporters__get",
        "parameters": [
          {
            "name": "q",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "minLength": 3,
              "title": "Search Query",
              "description": "Query string used for searching through exporters."
            },
            "description": "Query string used for searching through exporters."
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "anyOf": [
                {
                  "type": "integer",
                  "minimum": 1
                },
                {
                  "type": "null"
                }
              ],
              "description": "Page number. Omit for a plain list.",
              "title": "Page"
            },
            "description": "Page number. Omit for a plain list."
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "maximum": 500,
              "minimum": 1,
              "description": "Items per page (max 500). Only used with page.",
              "default": 50,
              "title": "Limit"
            },
            "description": "Items per page (max 500). Only used with page."
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "List of exporters (plain array or paginated envelope)",
            "content": {
              "application/json": {
                "schema": {},
                "examples": {
                  "plain_list": {
                    "summary": "Without page param (backward-compatible)",
                    "value": [
                      {
                        "id": 1,
                        "name": "Google Sheets Exporter",
                        "description": "Push data to Google Sheets",
                        "dataset": 42
                      }
                    ]
                  },
                  "paginated": {
                    "summary": "With ?page=1&limit=50",
                    "value": {
                      "items": [
                        {
                          "id": 1,
                          "name": "Google Sheets Exporter",
                          "description": "Push data to Google Sheets",
                          "dataset": 42
                        }
                      ],
                      "page": 1,
                      "limit": 50,
                      "has_next_page": false,
                      "total_count": 1
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Forbidden"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/exporters/{exporter_id}": {
      "get": {
        "tags": [
          "Exporter"
        ],
        "summary": "Get a specific exporter",
        "description": "Retrieve detailed information about a specific exporter by its ID, including its input parameters and output fields.",
        "operationId": "get_exporter_v1_exporters__exporter_id__get",
        "parameters": [
          {
            "name": "exporter_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the exporter to retrieve",
              "title": "Exporter Id"
            },
            "description": "The ID of the exporter to retrieve"
          },
          {
            "name": "authorization",
            "in": "query",
            "required": false,
            "schema": {
              "anyOf": [
                {
                  "type": "integer"
                },
                {
                  "type": "null"
                }
              ],
              "description": "Optional connection id used to fetch provider dynamic fields (HubSpot/Pipedrive properties). When omitted, the first active workspace connection is used.",
              "title": "Authorization"
            },
            "description": "Optional connection id used to fetch provider dynamic fields (HubSpot/Pipedrive properties). When omitted, the first active workspace connection is used."
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ExporterParams"
                },
                "example": {
                  "id": 1,
                  "name": "Create or update HubSpot company records",
                  "description": "Push company data to HubSpot",
                  "dataset": 42,
                  "params": [
                    {
                      "name": "id",
                      "is_required": false,
                      "type_field": "text",
                      "description": "Company ID"
                    }
                  ],
                  "additional_params": [
                    {
                      "name": "domain",
                      "label": "Company Domain Name"
                    },
                    {
                      "name": "name",
                      "label": "Company name"
                    }
                  ],
                  "response_fields": [
                    {
                      "name": "id",
                      "type_field": "text"
                    }
                  ]
                }
              }
            }
          },
          "403": {
            "description": "Forbidden access"
          },
          "404": {
            "description": "Exporter not found"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/tasks/{task_id}": {
      "get": {
        "tags": [
          "Get enrichment data or status"
        ],
        "summary": "Get task data or status",
        "description": "Retrieve the data (or results) of an enrichment run by the task id. If the request is still processing, the status field will show a 'processing' status, if the request is completed, your data will be returned in the 'data' key. The task_id is provided as a response when you launch an enrichment task.",
        "operationId": "get_status_request_v1_tasks__task_id__get",
        "parameters": [
          {
            "name": "task_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "description": "The unique identifier of the task whose status you are querying.",
              "title": "Task Id"
            },
            "description": "The unique identifier of the task whose status you are querying."
          },
          {
            "name": "include_partial",
            "in": "query",
            "required": false,
            "schema": {
              "type": "boolean",
              "default": false,
              "title": "Include Partial"
            },
            "description": "While a bulk task is still running, also return the rows that have already finished. Off by default: it makes every poll read the whole result set."
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "The task status along with any associated data or errors.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/app__api__v1__task__Task"
                },
                "examples": {
                  "processing": {
                    "summary": "Processing Task",
                    "value": {
                      "task_id": "abc123",
                      "status": "processing",
                      "credits_spent": 0
                    }
                  },
                  "processing_bulk": {
                    "summary": "Processing Bulk Task",
                    "value": {
                      "task_id": "abc123",
                      "status": "processing",
                      "progress": {
                        "total": 100,
                        "completed": 42,
                        "failed": 3,
                        "processing": 55
                      },
                      "credits_spent": 4.2
                    }
                  },
                  "completed": {
                    "summary": "Completed Task",
                    "value": {
                      "task_id": "abc123",
                      "status": "completed",
                      "data": {
                        "some_key": "some_value"
                      },
                      "credits_spent": 12
                    }
                  },
                  "failed": {
                    "summary": "Failed Task",
                    "value": {
                      "task_id": "abc123",
                      "status": "failed",
                      "error": "An error message",
                      "credits_spent": 0
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Forbidden access",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Forbidden"
                }
              }
            }
          },
          "404": {
            "description": "Not Found: Task with specified ID does not exist."
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/tasks/{task_id}/cancel": {
      "post": {
        "tags": [
          "Get enrichment data or status"
        ],
        "summary": "Cancel a running task",
        "description": "Stop a running task and refund what its unfinished requests reserved. Rows that already finished keep their results, so poll the task afterwards to collect them. A task that has already reached a terminal status returns 409.",
        "operationId": "cancel_task_v1_tasks__task_id__cancel_post",
        "parameters": [
          {
            "name": "task_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "description": "The unique identifier of the task to cancel.",
              "title": "Task Id"
            },
            "description": "The unique identifier of the task to cancel."
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "The task was cancelled.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/app__api__v1__task__Task"
                },
                "example": {
                  "task_id": "abc123",
                  "status": "cancelled",
                  "progress": {
                    "total": 100,
                    "completed": 42,
                    "failed": 3,
                    "processing": 55
                  },
                  "credits_spent": 4.2
                }
              }
            }
          },
          "403": {
            "description": "Forbidden access",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Forbidden"
                }
              }
            }
          },
          "404": {
            "description": "Not Found: Task with specified ID does not exist."
          },
          "409": {
            "description": "The task has already finished.",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Task has already finished"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/create": {
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Create a table",
        "description": "Create a new table in your workspace. Optionally specify a name, column names, and number of empty rows. By default the table is created with columns column1/column2/column3 and 0 rows.",
        "operationId": "Create_a_table_v1_table_create_post",
        "parameters": [
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "anyOf": [
                  {
                    "$ref": "#/components/schemas/CreateTableRequest"
                  },
                  {
                    "type": "null"
                  }
                ],
                "title": "Body"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Table created successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Table"
                },
                "example": {
                  "identifier": "123e4567-e89b-12d3-a456-426614174000",
                  "name": "My Table",
                  "created_at": "2023-05-01T12:00:00Z",
                  "updated_at": "2023-05-01T12:00:00Z",
                  "table_url": "https://databar.ai/tables?table=123e4567-e89b-12d3-a456-426614174000&workspace=abc12345-6789-0abc-def0-123456789abc"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "410": {
            "description": "Expired token",
            "content": {
              "application/json": {
                "example": {
                  "detail": "The token has expired"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}": {
      "delete": {
        "tags": [
          "Table"
        ],
        "summary": "Delete a table",
        "description": "Permanently delete a table and all its rows by UUID.",
        "operationId": "Delete_table_v1_table__table_uuid__delete",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table to delete",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table to delete"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {}
              }
            }
          },
          "204": {
            "description": "Table deleted successfully"
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      },
      "patch": {
        "tags": [
          "Table"
        ],
        "summary": "Rename a table",
        "description": "Rename a table by its UUID.",
        "operationId": "Update_table_v1_table__table_uuid__patch",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RenameTableRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Table"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden"
          },
          "404": {
            "description": "Table not found"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/": {
      "get": {
        "tags": [
          "Table"
        ],
        "summary": "Get all workspace tables",
        "description": "Retrieves all tables currently in your workspace, including their name, created date, and identifiers.",
        "operationId": "Get_tables_v1_table__get",
        "parameters": [
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Tables retrieved successfully",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/Table"
                  },
                  "title": "Response Get Tables V1 Table  Get"
                },
                "example": [
                  {
                    "identifier": "123e4567-e89b-12d3-a456-426614174000",
                    "name": "My Table 1",
                    "created_at": "2023-05-01T12:00:00Z",
                    "updated_at": "2023-05-01T12:00:00Z",
                    "table_url": "https://databar.ai/tables?table=123e4567-e89b-12d3-a456-426614174000&workspace=abc12345-6789-0abc-def0-123456789abc"
                  },
                  {
                    "identifier": "223e4567-e89b-12d3-a456-426614174001",
                    "name": "My Table 2",
                    "created_at": "2023-05-01T12:00:00Z",
                    "updated_at": "2023-05-01T12:00:00Z",
                    "table_url": "https://databar.ai/tables?table=223e4567-e89b-12d3-a456-426614174001&workspace=abc12345-6789-0abc-def0-123456789abc"
                  }
                ]
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/rows": {
      "get": {
        "tags": [
          "Table"
        ],
        "summary": "Get table rows",
        "description": "Get rows from a table with pagination and optional filtering.\n\n**Filtering:** Use the `filter` query parameter with a JSON-encoded object. Keys are column names, values are objects with one operator.\n\n**Operators:**\n- `equals` \u2014 exact match\n- `contains` \u2014 substring match (case-insensitive)\n- `not_equals` \u2014 excludes exact match\n- `is_empty` \u2014 column value is null (pass `true`)\n- `is_not_empty` \u2014 column value is not null (pass `true`)\n\nMultiple column filters use AND logic.\n\n**Examples:**\n- `?filter={\"company\":{\"equals\":\"OpenAI\"}}`\n- `?filter={\"name\":{\"contains\":\"Data\"}}`\n- `?filter={\"name\":{\"contains\":\"a\"},\"revenue\":{\"equals\":\"5000\"}}`\n- `?filter={\"email\":{\"is_not_empty\":true}}`",
        "operationId": "Get_table_rows_v1_table__table_uuid__rows_get",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table to retrieve",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table to retrieve"
          },
          {
            "name": "per_page",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "maximum": 500,
              "description": "Number of items per page (max 500).",
              "default": 100,
              "title": "Per Page"
            },
            "description": "Number of items per page (max 500)."
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "minimum": 1,
              "description": "Page number to retrieve.",
              "default": 1,
              "title": "Page"
            },
            "description": "Page number to retrieve."
          },
          {
            "name": "filter",
            "in": "query",
            "required": false,
            "schema": {
              "anyOf": [
                {
                  "type": "string"
                },
                {
                  "type": "null"
                }
              ],
              "description": "JSON-encoded filter object. Keys are column names, values are objects with one operator. Operators: equals, contains, not_equals, is_empty, is_not_empty. Example: {\"company\":{\"contains\":\"tech\"},\"status\":{\"equals\":\"active\"}}",
              "examples": [
                "{\"company\":{\"contains\":\"tech\"}}",
                "{\"email\":{\"is_not_empty\":true}}"
              ],
              "title": "Filter"
            },
            "description": "JSON-encoded filter object. Keys are column names, values are objects with one operator. Operators: equals, contains, not_equals, is_empty, is_not_empty. Example: {\"company\":{\"contains\":\"tech\"},\"status\":{\"equals\":\"active\"}}"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Table retrieved successfully",
            "content": {
              "application/json": {
                "schema": {
                  "title": "Response Get Table Rows V1 Table  Table Uuid  Rows Get"
                },
                "example": {
                  "has_next_page": true,
                  "total_count": 40,
                  "page": 1,
                  "data": [
                    {
                      "id": "fec5c2e3-1f18-491b-a875-5c274f052357",
                      "column1": "data1",
                      "column2": "data2"
                    }
                  ]
                }
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      },
      "patch": {
        "tags": [
          "Table"
        ],
        "summary": "Partial update of multiple rows",
        "description": "Update specific fields in multiple rows at once. Uses human-readable column names.\n\n**overwrite** controls whether existing non-empty values are replaced:\n- `true` (default) \u2014 always set the new value.\n- `false` \u2014 only fill in fields that are currently empty.\n\nIf a row UUID is not found the result entry will contain `\"ok\": false` with an error object `{\"code\": \"ROW_NOT_FOUND\"}`.",
        "operationId": "Batch_update_rows_v1_table__table_uuid__rows_patch",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BatchUpdateRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BatchUpdateResponse"
                }
              }
            }
          },
          "400": {
            "description": "Validation error (BATCH_TOO_LARGE, UNKNOWN_COLUMNS, INVALID_DATA).",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SDKErrorResponse"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Insert multiple rows into a table",
        "description": "Add rows to a table in batch. Uses human-readable column names.\n\n**options.allow_new_columns** \u2014 when `true`, any column name in `fields` that doesn't exist yet will be auto-created as a text column.\n\n**options.dedupe** \u2014 when `enabled: true`, rows whose `keys` columns match an existing row are skipped (`action: skipped_duplicate`) instead of inserted.",
        "operationId": "Batch_insert_rows_v1_table__table_uuid__rows_post",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BatchInsertRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BatchInsertResponse"
                }
              }
            }
          },
          "400": {
            "description": "Validation error (BATCH_TOO_LARGE, UNKNOWN_COLUMNS, INVALID_DATA).",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SDKErrorResponse"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/rows/delete": {
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Delete rows from a table",
        "description": "Delete specific rows from a table by their UUIDs.",
        "operationId": "Delete_rows_v1_table__table_uuid__rows_delete_post",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/DeleteRowsRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Rows deleted successfully",
            "content": {
              "application/json": {
                "schema": {},
                "example": {
                  "status": "deleted"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden"
          },
          "404": {
            "description": "Table not found"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/columns": {
      "get": {
        "tags": [
          "Table"
        ],
        "summary": "Get table columns",
        "description": "Get a tables columns by its ID.",
        "operationId": "Get_table_columns_v1_table__table_uuid__columns_get",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table to retrieve",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table to retrieve"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Table retrieved successfully",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/Column"
                  },
                  "title": "Response Get Table Columns V1 Table  Table Uuid  Columns Get"
                },
                "example": [
                  {
                    "identifier": "42902e11-fa09-4abd-a627-77c07fc40cde",
                    "internal_name": "de7ed8b2f4f34991b32f597877f7e97f",
                    "additional_intenal_name": "column1",
                    "name": "Column1",
                    "type_of_value": "text",
                    "data_processor_id": 1
                  }
                ]
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Add a column to a table",
        "description": "Create a new column on a table. Type defaults to 'text'.",
        "operationId": "Create_column_v1_table__table_uuid__columns_post",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateColumnRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateColumnResponse"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden"
          },
          "404": {
            "description": "Table not found"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/columns/{column_id}": {
      "patch": {
        "tags": [
          "Table"
        ],
        "summary": "Rename a column",
        "description": "Rename an existing column on a table.",
        "operationId": "Update_column_v1_table__table_uuid__columns__column_id__patch",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "column_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the column to rename",
              "title": "Column Id"
            },
            "description": "The UUID of the column to rename"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RenameColumnRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateColumnResponse"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden"
          },
          "404": {
            "description": "Table or column not found"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Table"
        ],
        "summary": "Delete a column from a table",
        "description": "Delete a column from a table by its UUID.",
        "operationId": "Delete_column_v1_table__table_uuid__columns__column_id__delete",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "column_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the column to delete",
              "title": "Column Id"
            },
            "description": "The UUID of the column to delete"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Column deleted successfully",
            "content": {
              "application/json": {
                "schema": {}
              }
            }
          },
          "403": {
            "description": "Forbidden"
          },
          "404": {
            "description": "Table or column not found"
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/add-enrichment": {
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Add enrichment to table",
        "description": "Add an enrichment to a table by its UUID.",
        "operationId": "Add_enrichment_to_table_v1_table__table_uuid__add_enrichment_post",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AddEnrichment"
              },
              "examples": {
                "with_column_uuid": {
                  "summary": "Mapping with column UUID",
                  "description": "Pass the column identifier (UUID) from GET /v1/table/{uuid}/columns.",
                  "value": {
                    "enrichment": 1,
                    "mapping": {
                      "email": {
                        "value": "42902e11-fa09-4abd-a627-77c07fc40cde",
                        "type": "mapping"
                      },
                      "country": {
                        "value": "US",
                        "type": "simple"
                      }
                    }
                  }
                },
                "with_column_name": {
                  "summary": "Mapping with column name from rows",
                  "description": "Use the column name as it appears in GET /v1/table/{uuid}/rows response.",
                  "value": {
                    "enrichment": 1,
                    "mapping": {
                      "email": {
                        "value": "email_address",
                        "type": "mapping"
                      },
                      "country": {
                        "value": "US",
                        "type": "simple"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Enrichment added successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/AddEnrichmentResponse"
                },
                "example": {
                  "id": 42,
                  "enrichment_name": "Email Verification"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/add-waterfall": {
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Add waterfall to table",
        "description": "Add a waterfall to a table by its UUID. A waterfall tries multiple data providers in sequence until one returns a result.\n\nUse `GET /v1/waterfalls` to list available waterfalls and their parameters, enrichments, and email verifiers.\n\nAfter adding, run the waterfall with `POST /v1/table/{uuid}/run-enrichment/{id}`.",
        "operationId": "Add_waterfall_to_table_v1_table__table_uuid__add_waterfall_post",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AddWaterfall"
              },
              "examples": {
                "email_getter": {
                  "summary": "Email finder waterfall",
                  "description": "Find emails using first name, last name and company columns.",
                  "value": {
                    "waterfall": "email_getter",
                    "enrichments": [
                      833,
                      966
                    ],
                    "mapping": {
                      "first_name": "first_name",
                      "last_name": "last_name",
                      "company": "company"
                    },
                    "email_verifier": 10
                  }
                },
                "with_column_uuids": {
                  "summary": "Mapping with column UUIDs",
                  "description": "Pass column identifier UUIDs from GET /v1/table/{uuid}/columns.",
                  "value": {
                    "waterfall": "email_getter",
                    "enrichments": [
                      833,
                      966
                    ],
                    "mapping": {
                      "first_name": "42902e11-fa09-4abd-a627-77c07fc40cde",
                      "last_name": "53013f22-gb10-5bce-b738-88d18gd51def",
                      "company": "64124g33-hc21-6cdf-c849-99e29he62efg"
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Waterfall added successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/AddWaterfallResponse"
                },
                "example": {
                  "id": 42,
                  "waterfall_name": "Email finder waterfall"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "400": {
            "description": "Invalid request",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Column 'company' not found in the table"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/enrichments": {
      "get": {
        "tags": [
          "Table"
        ],
        "summary": "Get enrichments in table",
        "description": "List all enrichments configured on a table. Returns enrichment IDs, parameter mappings, and status for each enrichment attached to the specified table.",
        "operationId": "Get_table_enrichments_v1_table__table_uuid__enrichments_get",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Table enrichments retrieved successfully",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/Enrichment"
                  },
                  "title": "Response Get Table Enrichments V1 Table  Table Uuid  Enrichments Get"
                },
                "example": [
                  {
                    "id": "1",
                    "name": "Enrichment1"
                  },
                  {
                    "id": "2",
                    "name": "My Table"
                  }
                ]
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/waterfalls": {
      "get": {
        "tags": [
          "Table"
        ],
        "summary": "Get table waterfalls",
        "description": "Get all waterfalls installed on a table. Use the returned `id` with `POST /v1/table/{uuid}/run-enrichment/{id}` to run.",
        "operationId": "Get_table_waterfalls_v1_table__table_uuid__waterfalls_get",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Table waterfalls retrieved successfully",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/InstalledWaterfall"
                  },
                  "title": "Response Get Table Waterfalls V1 Table  Table Uuid  Waterfalls Get"
                },
                "example": [
                  {
                    "id": 42,
                    "waterfall_name": "Email finder waterfall"
                  },
                  {
                    "id": 55,
                    "waterfall_name": "Phone number waterfall"
                  }
                ]
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/run-enrichment/{enrichment_id}": {
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Run table enrichment or waterfall",
        "description": "Run a specific enrichment or waterfall on a table.\n\nWorks for both enrichments (from `POST /v1/table/{uuid}/add-enrichment`) and waterfalls (from `POST /v1/table/{uuid}/add-waterfall`). Use the `id` returned when adding.\n\n**run_strategy** controls which rows are processed:\n- `run_all` (default) \u2014 run on every row.\n- `run_empty` \u2014 only run on rows where the result is empty.\n\n**row_ids** (optional) \u2014 list of specific row UUIDs to process. When provided, only those rows are processed (subject to run_strategy).",
        "operationId": "Run_table_enrichment_or_waterfall_v1_table__table_uuid__run_enrichment__enrichment_id__post",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "enrichment_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "description": "The ID of the table enrichment to run",
              "title": "Enrichment Id"
            },
            "description": "The ID of the table enrichment to run"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "anyOf": [
                  {
                    "$ref": "#/components/schemas/RunEnrichmentRequest"
                  },
                  {
                    "type": "null"
                  }
                ],
                "title": "Data"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Enrichment run started successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RunEnrichmentResponse"
                },
                "example": {
                  "status": "queued",
                  "processing_rows": 150
                }
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table or enrichment not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not found"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/add-exporter": {
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Add exporter to table",
        "description": "Add an exporter (CRM/destination) to a table by its UUID.\n\nUse `GET /v1/exporters` to list available exporters and `GET /v1/exporters/{id}` to see required parameters.\n\nAfter adding, run the exporter with `POST /v1/table/{uuid}/run-enrichment/{id}`.",
        "operationId": "Add_exporter_to_table_v1_table__table_uuid__add_exporter_post",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AddExporter"
              },
              "examples": {
                "with_column_uuid": {
                  "summary": "Mapping with column UUID",
                  "value": {
                    "exporter": 1,
                    "mapping": {
                      "email": {
                        "value": "42902e11-fa09-4abd-a627-77c07fc40cde",
                        "type": "mapping"
                      }
                    }
                  }
                },
                "with_column_name": {
                  "summary": "Mapping with column name",
                  "description": "Use the column name as it appears in GET /v1/table/{uuid}/rows response.",
                  "value": {
                    "exporter": 1,
                    "mapping": {
                      "email": {
                        "value": "email_address",
                        "type": "mapping"
                      },
                      "list_id": {
                        "value": "my-list-123",
                        "type": "simple"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Exporter added successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/AddExporterResponse"
                },
                "example": {
                  "id": 42,
                  "exporter_name": "Google Sheets Exporter"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "400": {
            "description": "Invalid request",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Column 'email' not found in the table"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/exporters": {
      "get": {
        "tags": [
          "Table"
        ],
        "summary": "Get table exporters",
        "description": "Get all exporters installed on a table. Use the returned `id` with `POST /v1/table/{uuid}/run-enrichment/{id}` to run.",
        "operationId": "Get_table_exporters_v1_table__table_uuid__exporters_get",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "responses": {
          "200": {
            "description": "Table exporters retrieved successfully",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/InstalledExporter"
                  },
                  "title": "Response Get Table Exporters V1 Table  Table Uuid  Exporters Get"
                },
                "example": [
                  {
                    "id": 42,
                    "name": "Google Sheets Exporter"
                  },
                  {
                    "id": 55,
                    "name": "HubSpot CRM"
                  }
                ]
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Not allowed"
                }
              }
            }
          },
          "404": {
            "description": "Table not found",
            "content": {
              "application/json": {
                "example": {
                  "detail": "Table not found"
                }
              }
            }
          },
          "422": {
            "description": "Validation Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HTTPValidationError"
                }
              }
            }
          }
        }
      }
    },
    "/v1/table/{table_uuid}/rows/upsert": {
      "post": {
        "tags": [
          "Table"
        ],
        "summary": "Update or create rows by key",
        "description": "For each row, match on a single **key** column:\n\n- **0 matches** \u2192 a new row is created (`action: created`).\n- **1 match** \u2192 the existing row is updated (`action: updated`).\n- **>1 matches** \u2192 returns an `AMBIGUOUS_MATCH` error for that row.\n\nThe `key` dict must contain exactly one entry `{column_name: value}`.",
        "operationId": "Upsert_rows_v1_table__table_uuid__rows_upsert_post",
        "parameters": [
          {
            "name": "table_uuid",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "description": "The UUID of the table",
              "title": "Table Uuid"
            },
            "description": "The UUID of the table"
          },
          {
            "name": "x-apikey",
            "in": "header",
            "required": true,
            "schema": {
              "type": "string",
              "title": "API Key",
              "description": "API Key for authentication"
            },
            "description": "API Key for authentication"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpsertRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful Response",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/UpsertResponse"
                }
              }
            }
          },
          "400": {
            "description": "Validation error (BATCH_TOO_LARGE, UNKNOWN_COLUMNS, INVALID_DATA).",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SDKErrorResponse"
[...]
